Package org.apache.commons.math3.fitting

# Class SimpleCurveFitter

java.lang.Object
org.apache.commons.math3.fitting.AbstractCurveFitter
org.apache.commons.math3.fitting.SimpleCurveFitter

public class SimpleCurveFitter extends AbstractCurveFitter
Fits points to a user-defined `function`.

Since:
  3.4

## Nested Class Summary

## Nested classes/interfaces inherited from class org.apache.commons.math3.fitting.AbstractCurveFitter

`AbstractCurveFitter.TheoreticalValuesFunction`

## Method Summary

Modifier and Type
Method
Description
`static SimpleCurveFitter`
`create(ParametricUnivariateFunction f, double[] start)`
Creates a curve fitter.
`protected LeastSquaresProblem`
`getProblem(Collection<WeightedObservedPoint> observations)`
Creates a least squares problem corresponding to the appropriate curve.
`SimpleCurveFitter`
`withMaxIterations(int newMaxIter)`
Configure the maximum number of iterations.
`SimpleCurveFitter`
`withStartPoint(double[] newStart)`
Configure the start point (initial guess).

### Methods inherited from class org.apache.commons.math3.fitting.AbstractCurveFitter

`fit, getOptimizer`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Method Details

### create

public static SimpleCurveFitter create(ParametricUnivariateFunction f, double[] start)
Creates a curve fitter. The maximum number of iterations of the optimization algorithm is set to `Integer.MAX_VALUE`.

Parameters:
  `f` - Function to fit.
  `start` - Initial guess for the parameters. Cannot be `null`. Its length must be consistent with the number of parameters of the function to fit.
Returns:
  a curve fitter.
See Also:
  - `withStartPoint(double[])`
  - `withMaxIterations(int)`

### withStartPoint

public SimpleCurveFitter withStartPoint(double[] newStart)
Configure the start point (initial guess).

Parameters:
  `newStart` - new start point (initial guess)
Returns:
  a new instance.

### withMaxIterations

public SimpleCurveFitter withMaxIterations(int newMaxIter)
Configure the maximum number of iterations.

Parameters:
  `newMaxIter` - maximum number of iterations
Returns:
  a new instance.

### getProblem

protected LeastSquaresProblem getProblem(Collection<WeightedObservedPoint> observations)
Creates a least squares problem corresponding to the appropriate curve.

Specified by:
  `getProblem` in class `AbstractCurveFitter`
Parameters:
  `observations` - Sample points.
Returns:
  the least squares problem to use for fitting the curve to the given `points`.